Device Manager: Welcome

You can use Device Manager to install and update the drivers for hardware devices, change the hardware settings for those devices, and troubleshoot problems.

A device driver is software that allows Windows to communicate with a specific hardware device. Before Windows can use any new hardware, a device driver must be installed.

  • Overview of Device Manager

  • Open Device Manager

  • Viewing Device Information

  • Installing Devices and their Drivers

  • Configuring Device Properties

  • Uninstalling and Reinstalling Devices

  • Additional Device Manager Resources

  • Device Management Glossary


Overview of Device Manager

Device Manager provides you with a graphical view of the hardware that is installed on your computer. All devices communicate with Windows through a piece of software called a device driver. You can use Device Manager to install and update the drivers for your hardware devices, modify hardware settings for those devices, and troubleshoot problems.

Uses for Device Manager

You can use Device Manager to:

  • Determine whether the hardware on your computer is working properly.

  • Change hardware configuration settings.

  • Identify the device drivers that are loaded for each device, and obtain information about each device driver.

  • Change advanced settings and properties for devices. Install updated device drivers.

  • Enable, disable, and uninstall devices.

  • Roll back to the previous version of a driver.

  • View the devices based on their type, by their connection to the computer, or by the resources they use.

  • Show or hide hidden devices that are not critical to view but might be necessary for advanced troubleshooting

You will typically use Device Manager to check the status of your hardware and update device drivers on your computer. Advanced users who have a thorough understanding of computer hardware might also use Device Manager's diagnostic features to resolve device conflicts and change resource settings.

Ordinarily, you will not need to use Device Manager to change resource settings because resources are allocated automatically by the system during hardware setup.

You can use Device Manager to manage devices only on a local computer. On a remote computer, Device Manager will work only in read-only mode, allowing you to view, but not change the hardware configuration of that computer.
Additional references

Open Device Manager

Viewing Device Information

Installing Devices and their Drivers

Configuring Device Properties

Uninstalling and Reinstalling Devices

Additional Device Manager Resources

Device Management Glossary


Open Device Manager

Device Manager can be started in several ways. This topic provides two procedures you can use to start Device Manager on Microsoft® Windows Vista® and Windows Server® 2008, both from the Windows interface and from a command line.

Any user account can be used to complete this procedure. However, only members of the Administrators group can make changes to the devices.

Opening Device Manager

You can open Device Manager in any of the following ways:

  • Using the Windows interface

  • Using a command line

  • Using Computer Management

  • From a remote computer

Using the Windows interface

The following procedure allows you to open Device Manager through the Windows user interface.

To open Device Manager by using the Windows interface

  1. Click Start, and then click Control Panel.

  2. Click Hardware and Sound.

  3. Click Device Manager. One of the following occurs:

    • If you are logged on as the built-in Administrator account, Device Manager opens.

    • If you are logged on as a user that is a member of the Administrators group, then the User Account Control dialog appears, and you must click Continue to open Device Manager.

    • If you are logged on as a standard user, a message appears indicating that you cannot make any changes to the devices. Click OK to open Device Manager in read-only mode.

Using a command line

The following procedure allows you to open Device Manager from any command prompt.

To open Device Manager by using the command line

  • At a command prompt, in the Start Search box, or in the Run box, type the following command:

    mmc devmgmt.msc

    One of the following occurs:

    • If you are logged on as the built-in Administrator account, Device Manager opens.

    • If you are logged on as a user that is a member of the Administrators group, then the User Account Control dialog appears, and you must click Continue to open Device Manager.

    • If you are logged on as a standard user, a message appears indicating that you cannot make any changes to the devices. Click OK to open Device Manager in read-only mode.

Using Computer Management

The following procedures allow you to open Computer Management, which includes Device Manager as one of its components.

Note

This procedure works only on Windows Vista. On Windows Server 2008, these steps start the Server Manager program. To start Computer Manager on Windows Server 2008, use the steps in the next procedure by using the command prompt.

To open Computer Management by using the Windows interface

  1. Click Start, then right-click Computer, and then click Manage.

    One of the following occurs:

    • If you are logged on as the built-in Administrator account, Computer Management opens.

    • If you are logged on as a user that is a member of the Administrators group, then the User Account Control dialog appears, and you must click Continue to open Computer Management.

    • If you are logged on as a standard user, Computer Management opens.

  2. Click Device Manager in the navigation pane.

    One of the following occurs:

    • If you are an administrator, Device Manager appears in the details pane.

    • If you are a standard user, a message appears indicating that you cannot make any changes to the devices. Click OK to open Device Manager in read-only mode in the details pane.
To open Computer Management by using the command line

  1. At a command prompt, in the Start Search box, or the Run box, type the command:

    mmc compmgmt.msc

    One of the following occurs:

    • If you are logged on as the built-in Administrator account, Computer Management opens.

    • If you are logged on as a user that is a member of the Administrators group, then the User Account Control dialog appears, and you must click Continue to open Computer Management.

    • If you are logged on as a standard user, Computer Management opens.

  2. Click Device Manager in the navigation pane.

    One of the following occurs:

    • If you are an administrator, Device Manager appears in the details pane.

    • If you are a standard user, a message appears indicating that you cannot make any changes to the devices. Click OK to open Device Manager in read-only mode in the details pane.

From a remote computer

To open Device Manager on a remote computer

  1. Open Computer Management using either of the procedures in the previous section.

  2. On the Action menu, click Connect to another computer.

  3. In the Select Computer dialog box, do one of the following:

    • In the Another computer text box, type the name of the computer to access, and then click OK.

    • Click Browse, and then click Advanced to find the computer you want. Click OK when you have selected the correct computer.

    If the connection is successful, the name of the computer appears in parenthesis next to the Computer Management label in the upper left.

    Note

    Access to Device Manager on a remote computer in this manner is "read-only." You cannot make any changes to devices or their settings.
Additional references

Device Manager: Welcome

Additional Device Manager Resources

Device Management Glossary


Viewing Device Information

By using Device Manager, you can see the details of your hardware configuration, including their status, the drivers in use, and other information.

This section provides the following procedures about how to see information provided by Device Manager:

  • View Details and Status for a Device

  • View USB Power and Bandwidth Allocations for a Device

  • View Information About a Device Driver


View Details and Status for a Device

This topic provides procedures you can use to view information about a device.

  • View the status of a device

  • View devices based on their type, connection, or resources they use

  • View hidden devices

Any user account can be used to complete this procedure. However, only members of the Administrators group can make changes to any of the devices or their drivers.

View the status of a device

The status of a device shows whether the device has drivers installed, and whether Windows is able to communicate with the device.

To view the status of a device

  1. Open Device Manager.

  2. Double-click the type of device you want to view.

  3. Right-click the device you want, and then click Properties.

  4. On the General tab, the Device status area shows description of the current status.

    Note

    If the device is experiencing a problem, the type of problem is displayed. You might also see a problem code and number and a suggested solution. You can also submit a Windows Error Report to Microsoft by clicking Check for solutions, if that button is present.

View devices based on their type, connection, or resources they use

By default, devices are displayed in groups by their device type. Alternatively, you can view them based on how they are connected to the computer, such as the bus they are plugged into. You can also view the devices based on the resources they use.

To view devices based on their type, connection, or resources they use

  1. Open Device Manager.

  2. On the View menu, click one of the options listed in the following table:

    Option Description

    Devices by type

    Displays devices by the type of device installed, such as monitor or mouse. This is the default view. After you double-click the device type, each connection name is listed below the type.

    Devices by connection

    Displays devices by how they are connected in your computer. Each device is listed under the hardware to which it is connected. For example, if a small computer system interface (SCSI) card is listed, the devices attached to the SCSI card are listed beneath it.

    Resources by type

    Displays all allocated resources by the type of device using these resources. The types of resources are:

    • Direct memory access (DMA) channels

    • Input/output ports (I/O ports)

    • Interrupt request (IRQ)

    • Memory addresses

    Resources by connection

    Displays all allocated resources by connection type.

For more information about how to view device by their setup class, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

View hidden devices

The most common type of hidden device is one whose driver is installed, but the device is not currently attached. Follow the steps in this procedure to view the hidden devices on the computer.

To view hidden devices

  1. Open Device Manager.

  2. On the View menu, click Show hidden devices.
Additional references

Viewing Device Information

View USB Power and Bandwidth Allocations for a Device

View Information About a Device Driver


View USB Power and Bandwidth Allocations for a Device

This topic provides procedures you can use to view the power or bandwidth allocations for USB hubs and controllers.

  • View the power allocations for a USB hub

  • View the bandwidth allocations for a USB host controller

Any user account can be used to complete this procedure. However, only members of the Administrators group can make changes to any of the devices or their drivers.

View the power allocations for a USB hub

Hubs for USB devices are self-powered or bus-powered. A self-powered hub has its own power supply and provides maximum power to the device. A bus-powered hub draws its power from the USB to which it is connected and provides minimum power. Devices requiring a lot of power, such as cameras, should be plugged into self-powered hubs.

You can check the power allocations for a USB hub to detect situations in which too many devices are using the hub.

To view the power allocations for a USB hub

  1. Open Device Manager.

  2. Double-click Universal serial bus controllers.

  3. Right-click USB Root Hub (you might have multiple instances), and then click Properties.

  4. On the Power tab, view the power required by each device in the Attached devices list.

    Notes
    • Universal serial bus controller only appears if you have a USB port on your computer.
    • The Power tab only appears for USB hubs.

View the bandwidth allocations for a USB host controller

You can view bandwidth only for a universal serial bus (USB) controller. Some USB devices (for example, modems) might not appear because they do not report bandwidth requirements to the operating system.

Each USB controller has a fixed amount of bandwidth that all attached devices must share. If you suspect a bandwidth shortage for a USB controller, you can confirm this by viewing the bandwidth allocations currently being used by each device.

To view bandwidth allocations for a USB host controller

  1. Open Device Manager.

  2. Double-click Universal serial bus controllers.

  3. Right-click [NameBrand] Host Controller for your system, and then click Properties.

  4. On the Advanced tab, in the Bandwidth-consuming devices list, view the bandwidth used by each device.

    Note

    Universal serial bus controllers appears only if you have a USB port on your computer.
Additional references

Viewing Device Information

View Details and Status for a Device

View Information About a Device Driver


View Information About a Device Driver

This topic provides a procedure you can use to view details about the device drivers that are running on your computer.

Any user account can be used to complete this procedure. However, only members of the Administrators group can make changes to any of the devices or their drivers.

To view information about a device driver

  1. Open Device Manager.

  2. Find and right-click the specific device you want, and then click Properties.

  3. On the Driver tab, information about the currently installed driver is displayed.

  4. Click the Details button.

    The Driver File Details page appears with a list of the individual files that make up the driver.

Additional references

Viewing Device Information

Stage a Device Driver in the Driver Store

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version


Installing Devices and their Drivers

This section provides procedures you can use to install both Plug and Play and non-Plug and Play devices, and to maintain the device drivers that support the devices.

  • Understanding Device and Driver Installation

  • Install a Plug and Play Device

  • Install a Non-Plug and Play Device

  • Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

  • Stage a Device Driver in the Driver Store

  • Configure Windows to Search Additional Folders for Device Drivers

  • Configure Windows to Search Windows Update for Device Drivers

  • Update or Change a Device Driver

  • Roll Back a Device Driver to a Previous Version

  • Enable or Disable a Plug and Play Device

  • Start or Stop a Non-Plug and Play Device Driver

  • Configure the Startup Type for a Non-Plug and Play Device Driver


Understanding Device and Driver Installation

Windows supports the Plug and Play specifications that define how a computer can detect and configure newly added hardware and automatically install the device driver. Prior to Plug and Play, users needed to manually configure devices before attaching them to the computer.

Plug and Play hardware, combined with a Plug and Play–compatible operating system such as Microsoft® Windows Vista® and Windows Server® 2008, allow a user to plug in the hardware and Windows searches for an appropriate device driver package, automatically configuring it to work without interfering with other devices.

Because device driver software runs as if it is a part of the operating system with unrestricted access to the entire computer, it is critical that only known and authorized device drivers be permitted. To support this requirement for security, Windows Vista and Windows Server 2008 break the installation process into two steps:

Device installation in Windows

Device and device driver installation in Windows Vista and Windows Server 2008 operates as shown in the following diagram. "PnP" in the diagram refers to the Plug and Play service running in Windows. If any of the described security checks fail, or if an appropriate device driver package cannot be found, then the process stops.

Flowchart - Windows device driver installation
  1. When a user inserts a device, Windows detects the new hardware and signals the Plug and Play service to make the device operational.

  2. Plug and Play identifies the device.

  3. Plug and Play searches the driver store for a driver package that matches the device. If a matching package is not found, go to step 4. If a matching package is found, skip to step 8.

  4. Windows searches for a matching driver package by looking in the following locations, stopping as soon as a matching package is found:

    • Searching folders specified by the DevicePath registry entry. For more information, see Configure Windows to Search Additional Folders for Device Drivers.

    • Searching the Windows Update Web site. For more information, see Configure Windows to Search Windows Update for Device Drivers.

    • Prompting the user for media.

  5. Windows checks that the user has permission to place the driver package in the driver store. The user must have administrator credentials, or computer policy is set to allow standard users to install devices that have this identifier. For more information about this policy, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

  6. Windows checks that the driver package has a valid digital signature. If the driver package is signed by a certificate that is valid, but not found in the Trusted Publishers store, then Windows prompts the user for confirmation.

  7. Windows places a copy of the driver package in the driver store.

  8. PnP copies the driver files from the driver store to their operational locations, typically %systemroot%\windows32\drivers.

  9. PnP configures the registry to instruct Windows how to use the newly installed drivers.

  10. PnP starts the newly installed drivers. This step is repeated at each computer restart to reload the drivers.

In Windows Vista and Windows Server 2008, the process described in steps 3 through 7 is referred to as staging. During staging, Windows performs security checks, and then places the driver package in a secure location so it can by accessed by the Plug and Play service. In Windows Vista and Windows Server 2008 staging can be performed by an administrator as a separate step. For more information, see Stage a Device Driver in the Driver Store.

If you are an administrator for multiple computers, staging the device driver packages for your users provides significant benefit. Windows performs all of the required security checking during staging, including the verification of administrator rights and validation of digital signatures. After a driver package has been successfully staged, any user that logs on to that computer can install the drivers in the driver store by simply plugging in the appropriate device. There are no prompts, and no special permissions are required. The user simply plugs in the device and it works, without administrator or help desk intervention.
Additional references

For more information about the driver store and the staging process, see the Device Management and Installation documentation available on the Windows Server TechCenter (http://go.microsoft.com/fwlink/?linkid=62923).

Installing Devices and their Drivers

Install a Plug and Play Device

Install a Non-Plug and Play Device

Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

Stage a Device Driver in the Driver Store

Configure Windows to Search Additional Folders for Device Drivers

Configure Windows to Search Windows Update for Device Drivers

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version

Enable or Disable a Plug and Play Device

Start or Stop a Non-Plug and Play Device Driver

Configure the Startup Type for a Non-Plug and Play Device Driver


Install a Plug and Play Device

This topic provides a procedure that you can use to install a Plug and Play–compliant device in your computer.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. Review the details in "Additional considerations" in this topic.

To install a Plug and Play device

  1. Plug the new device into the computer.

  2. In the Found New Hardware dialog box choose one of the following:

    • Locate and install driver software. Selecting this option begins the installation process. Review the details in "Additional considerations" in this topic.

    • Ask me again later. The device is not installed and no configuration change is made to your computer. If the device is still plugged in the next time you log on to the computer, then this dialog box appears again.

    • Don't show this message again for this device. Selecting this option configures the Plug and Play service to not install the driver for this device, and does not make the device functional. To complete the installation of the device driver, you must detach the device and reattach it. For more information, see Uninstall or Reinstall a Device.

If the user selects Locate and install driver software, then the success of the installation depends on the following factors:

  • The device is supported by a driver package included with Windows. Driver packages included with Windows can be installed by standard users.

  • The administrator of the computer has staged the driver package in the driver store. For more information, see Stage a Device Driver in the Driver Store. Driver packages that are in the driver store can be installed by standard users.

  • The user has media with the driver package provided by the vendor. For more information, see the "Additional considerations" in this topic.
Additional considerations

By default, membership in the Administrators group, or equivalent, is the minimum required to install a new device whose driver is not present in the driver store. If the driver package is not present in the driver store, then standard users can install the device only if the following conditions are met:

  • The driver package is signed with a valid digital certificate. For more information, see the documentation on signing device drivers found on the Windows Server TechCenter (http://go.microsoft.com/fwlink/?linkid=62923).

  • The device setup class for the driver is stored in the Allow non-administrators to install drivers for these device classes computer policy. For more information, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

Additional references

Installing Devices and their Drivers

Install a Non-Plug and Play Device

Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

Stage a Device Driver in the Driver Store

Configure Windows to Search Additional Folders for Device Drivers

Configure Windows to Search Windows Update for Device Drivers

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version

Start or Stop a Non-Plug and Play Device Driver

Configure the Startup Type for a Non-Plug and Play Device Driver


Install a Non-Plug and Play Device

This topic provides a procedure that you can use to install a non-Plug and Play–compliant device in your computer.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To install a non-Plug and Play device

  1. Open Device Manager.

  2. Right-click the top node in the details pane.

  3. Click Add legacy hardware.

  4. In the Add Hardware Wizard, click Next, and then follow the instructions on your screen.
Additional references

Installing Devices and their Drivers

Install a Plug and Play Device

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version

Start or Stop a Non-Plug and Play Device Driver

Configure the Startup Type for a Non-Plug and Play Device Driver


Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

By default, only members of the Administrators group on a computer can install devices. This is because only an administrator can place a driver package into the driver store, a necessary step in the installation process. With Microsoft® Windows Vista® and Windows Server® 2008 you can configure computer policy on your computer to allow limited users the ability to install devices from specific device setup classes.

This topic provides procedures you can use to determine the device setup class for a hardware device, and then add that device setup class to the policy to allow a limited user to install drivers for that device without requiring elevated permissions.

  • Determine the device setup class for a specific hardware device

  • Configure policy to allow a limited user to stage devices for a specific device setup class

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

Determine the device setup class for a specific hardware device

Before you can grant permission to install a specific device, you must determine the device setup class that Windows uses to uniquely identify that device. You can do this by viewing the .inf file of the device driver package, or by viewing the properties of a currently installed device.

To determine the device setup class by viewing the.inf file of a device driver package

  1. Open the .inf file of device driver package in Notepad.

  2. Find the section beginning with the text [Version].

  3. Find the line in that section beginning with the text ClassGuid=.

  4. Copy the value to the right of the equals sign to the clipboard, and then paste it anywhere it is needed.
To determine the device setup class by viewing the properties of a currently installed device

  1. Install your device on a test computer.

  2. Open Device Manager on that computer.

  3. Find your device in the Device Manager tree.

  4. Double-click your device to display the Properties page.

  5. Click the Details tab.

  6. In the Property list, select Device class guid.

  7. Right-click the GUID, click Copy, and then paste it anywhere it is needed.

Configure policy to allow a limited user to stage devices for a specific device setup class

Windows supports policies that an administrator can use to control which devices can be installed by limited users. By default, only administrators can install devices. Windows enforces this policy during the staging of the device driver in the driver store. For more information about staging, see Stage a Device Driver in the Driver Store.

Note

This procedure is appropriate for a small number of computers. To effectively apply policy to a large number of computers, use a tool such as Group Policy. For information about Group Policy, see Group Policy on the Windows Server TechCenter (http://go.microsoft.com/fwlink/?linkid=55625).

To configure computer policy to allow a limited user to stage drivers for a specific device setup class

  1. Follow the steps in one of the previous procedures to determine the device setup class GUID for your device.

  2. Click Start, and then in the Start Search box, type mmc gpedit.msc, and then press Enter to run Local Group Policy Object Editor.

  3. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  4. In Local Group Policy Object Editor, under Local Computer Policy, double-click each of the following: Computer Configuration, Administrative Templates, System, and then Driver Installation.

  5. In the details pane, double-click Allow non-administrators users to install drivers for these device classes.

  6. Select Enabled to turn on the computer policy.

  7. Click Show to display the current list of approved device setup classes.

  8. In the Show Contents dialog box, click Add.

  9. In the Add Item dialog box, enter the GUID of the device setup class including the curly braces {}, and then click OK.

  10. Click OK to close the Show Contents dialog box.

  11. Click OK to close the computer policy.

    In the State column, the policy is now Enabled.

Limited users on this computer (or any computer to which this policy applies) can now install devices for this device setup class without requiring any elevated rights.

Important

The device driver package must still be signed in accordance with computer policy. If the certificate for the driver publisher is not in the Trusted Publishers certificate store, then the user will be prompted to accept the unverified certificate during the installation process.
Additional references

Installing Devices and their Drivers

Stage a Device Driver in the Driver Store

Configure Windows to Search Additional Folders for Device Drivers

Configure Windows to Search Windows Update for Device Drivers


Stage a Device Driver in the Driver Store

The driver store is a protected area of a computer that contains device driver packages that have been approved for installation on the computer. After a device driver package is in the driver store, a standard user on the computer can install its device without needing elevated user permissions.

This topic provides a procedure that an administrator can use to stage a device driver installation package in the driver store.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. Review the details in "Additional considerations" in this topic.

To stage a driver package in the driver store

  1. Open a command prompt that has administrator privileges. Click Start, All Programs, and Accessories, then right-click Command Prompt, and then click Run as Administrator.

    Note

    The PnPUtil command-line tool does not work unless you run the command prompt as an administrator.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. At the command prompt, type the command:

    pnputil.exe -a <PathToDriver>/<Driver>.inf

    Parameter Description

    -a

    Specifies that the driver package is to be added to the driver store.

    PathToDriver

    Specifies the path to the folder where the driver is currently located.

    Driver.inf

    Specifies the name of the .inf file that describes the driver package.
    Note

    To see all of the command-line parameters for the PnPUtil command, type the following at the command prompt: pnputil -?

  4. If the driver package is not signed, or is signed by a certificate that is not currently in the Trusted Publishers certificate store, the Windows Security dialog appears asking you to confirm whether the driver should be installed. View the details of the message to determine the problem with the driver's signature. If you are sure that the driver package is valid and safe, click Install to finish the staging operation.

  5. When staging is complete, the PnPUtil tool reports a Published name that is assigned to this package in the driver store. This name is the one that must reference if you want to delete the driver package from the store later. If you need to determine the published name for a driver package, use the command pnputil.exe -e, and then search the output for the driver you need.
Additional considerations
  • By default, membership in the Administrators group, or equivalent, is the minimum required to install a device driver package in the driver store. A standard user can install a driver package only if the following conditions are met:

    • The device driver package is signed with a valid digital certificate. For more information, see the documentation about signing device drivers found on the Microsoft TechCenter (http://go.microsoft.com/fwlink/?linkid=62923).

    • The device setup class for the driver is in the computer policy Allow limited users to install drivers for these device classes. For more information, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

Additional references

Installing Devices and their Drivers

Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

Configure Windows to Search Additional Folders for Device Drivers

Configure Windows to Search Windows Update for Device Drivers

Command-line syntax notation


Configure Windows to Search Additional Folders for Device Drivers

When a new device is detected, Windows checks the driver store to see if an appropriate driver package is staged there. If not, it checks several locations to find a driver package to place in the driver store. In order, these locations are:

  1. The folders specified in the DevicePath registry setting, as described in this topic.

  2. Windows Update on the Web. For more information see Configure Windows to Search Windows Update for Device Drivers.

  3. A file path or media provided by the user.

After Windows locates the driver package, it is copied to the driver store, and then installed from there.

This topic provides a procedure that you can use to modify the list of folders searched by Device Manager for a driver package.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To configure Windows to Search Additional Folders for Device Drivers

  1. Start Registry Editor. Click Start, and in the Start Search box type regedit.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. Navigate to the following registry key:

    HKEY_LOCAL_MACHINE/Software/Microsoft/Windows/Current Version

  4. In the details pane, double-click DevicePath.

  5. Add additional folder paths to the setting, separating each folder path with a semi-colon. Ensure that %systemroot%\inf is one of the folders included in the value.
Caution

Do not remove %systemroot%\inf from the DevicePath registry entry. Removal of that folder can break device driver installation.
Additional considerations
  • You can include paths using:

    • Drive letters and folders, such as c:\foldername

    • Environment variables, such as %systemdrive%\foldername

    • Network paths, such as \\server\share

    The list you specify must be on one line, with each folder separated by a semi-colon.

  • If the folders listed in the DevicePath registry entry contain other subfolders, the subfolders will also be included in the search. For example, including c:\ as one of the paths will cause Windows to search the entire drive.

  • Inclusion of a driver package in a folder referenced by the DevicePath registry entry does not remove any prompts created by the signature on the package. If the package is not signed, or signed by an unknown or untrusted publisher, then the user is still presented with dialog boxes to accept the publisher. Inclusion of the certificate used to sign the driver in the Trusted Publishers certificate store removes this additional prompt. For more information, see the documentation about signing device drivers on the Windows Server TechCenter (http://go.microsoft.com/fwlink/?linkid=62923).

Additional references

Install a Plug and Play Device

Install a Non-Plug and Play Device

Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

Stage a Device Driver in the Driver Store

Configure Windows to Search Windows Update for Device Drivers


Configure Windows to Search Windows Update for Device Drivers

When a new device is detected, Windows checks the driver store to see if an appropriate driver package is staged there. If not, it checks several locations to find a driver package. In order, these locations are:

  1. The folders specified in the DevicePath registry setting. For more information, see Configure Windows to Search Additional Folders for Device Drivers.

  2. Windows Update on the Web, as described in this topic.

  3. A file path or media after provided by the user.

After Windows locates the driver package, it is copied to the driver store, and then installed from there.

By default, Windows searches the Windows Update driver repository on the Internet if the driver cannot be automatically discovered locally. Administrators in managed environments may wish to exercise more control over their managed systems, and turn off the automatic search of Windows Update.

This topic provides a procedure that you can use to enable or disable searching Windows Update for device drivers.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To configure Windows to search additional folders for device drivers

  1. Start Local Group Policy Object Editor. Click Start, and then in the Start Search box, type mmc gpedit.msc.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. Open Local Computer Policy, Computer Configuration, Administrative Templates, System, Internet Communication Management, and then Internet Communication Settings.

  4. In the right-hand pane, double-click Turn off Windows Update device driver searching.

  5. Select one of the following:

    • Select Enabled to prevent Windows from searching Windows Update.

    • Select Disabled to always search Windows Update automatically when a driver is not found locally.

    • Select Not Configured to use the system default, which is to search Windows Update automatically.

  6. If you selected Disabled or Not Configured, then the policy found at Computer Configuration, Administrative Templates, System, Driver Installation, Turn off Windows Update device driver search prompt applies. That policy determines whether you are prompted for consent before searching Windows Update. If that policy is enabled, then Windows Update is searched silently without asking for consent first.

The following table shows the effect of different combinations of the two policy settings. The results show whether or not a prompt is displayed, and whether or not the search of Windows Update occurs.

Policy: Turn off Windows Update device driver searching | Policy: Turn off Windows Update device driver search prompt | Resulting Behavior
Enabled | Enabled | No prompt, and no search of Windows Update.
Enabled | Disabled | No prompt, and no search of Windows Update.
Enabled | Not Configured | No prompt, and no search of Windows Update.
Disabled | Enabled | No prompt. Automatic search of Windows Update.
Disabled | Disabled | User is prompted, and Windows Update is search if user approves.
Disabled | Not Configured | User is prompted, and Windows Update is search if user approves.
Not Configured | Enabled | No prompt. Automatic search of Windows Update.
Not Configured | Disabled | User is prompted, and Windows Update is search if user approves.
Not Configured | Not Configured | User is prompted, and Windows Update is search if user approves.
Additional references

Installing Devices and their Drivers

Stage a Device Driver in the Driver Store

Configure Computer Policy to Allow Non-Administrators to Install Specific Devices

Configure Windows to Search Additional Folders for Device Drivers


Update or Change a Device Driver

This topic provides a procedure that you can use to update or change the device driver used for a device.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. Review the details in "Additional considerations" in this topic.

To update or change the driver used for a device

  1. Open Device Manager.

  2. Double-click the type of device you want to update or change.

  3. Right-click the device you want, and then click Update Driver.

  4. Follow the instructions in the Update Driver Software wizard.
Additional considerations
  • When you are upgrading a driver or installing new hardware, your computer will automatically attempt to check folders specified in the DevicePath registry entry and the Windows Update Web site for an appropriate device driver. For more information, see Configure Windows to Search Windows Update for Device Drivers and Configure Windows to Search Additional Folders for Device Drivers.

  • By default, Administrators is the minimum group membership required to install a device whose driver package is not already in the driver store. A standard user can successfully install a driver package only if the following conditions are met:

    • The driver package is signed with a certificate that is present in the Trusted Publishers certificate store on the computer. For more information, see the documentation about signing device drivers found on the Windows Server TechCenter (http://go.microsoft.com/fwlink/?linkid=62923).

    • The device setup class for the driver is in the policy Allow limited users to install drivers for these device classes. For more information, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

Additional references

View Information About a Device Driver

Roll Back a Device Driver to a Previous Version

Start or Stop a Non-Plug and Play Device Driver

Configure the Startup Type for a Non-Plug and Play Device Driver


Roll Back a Device Driver to a Previous Version

This topic provides a procedure that you can use to return to an earlier version of a device driver.

A newer version of a device driver often adds functionality and fixes problems that were discovered in earlier versions. Rolling back a driver can cause the loss of that new functionality, and can reintroduce the problems that were addressed with the newer version.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. Review the details in "Additional considerations" in this topic.

To roll back to a previous version of a driver

  1. Open Device Manager.

  2. Right-click the device for which you want to roll back to the previous version of the driver, and then click Properties.

  3. Click the Drivers tab.

  4. Click Roll Back Driver.

  5. In the Driver Package rollback dialog box, click Yes.
Additional considerations
  • By default, membership in the Administrators group, or equivalent, is the minimum group membership required to modify device drivers on the computer. A standard user can modify a driver package only if the device setup class for the driver is in the Allow non-administrators to install drivers for these device classes computer policy. For more information, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

  • The Roll Back Driver button is only available if a previous version of the driver was installed. If the current driver for the device is the only one that was ever installed on this computer, then the Roll Back Driver button is not enabled.

Additional references

View Information About a Device Driver

Update or Change a Device Driver

Start or Stop a Non-Plug and Play Device Driver

Configure the Startup Type for a Non-Plug and Play Device Driver


Enable or Disable a Plug and Play Device

This topic provides a procedure you can use to start or stop the device driver for a Plug and Play device. These procedures do not apply to devices that do not conform to the Plug and Play specification. For non-Plug and Play devices, see Start or Stop a Non-Plug and Play Device Driver.

  • Enable a device

  • Disable a device

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

Enable a device

To enable a Plug and Play device

  1. Open Device Manager.

  2. Right-click the device you want, and then click Enable.

    Enable will only be listed if the device is disabled.

You can also enable a device at the device's Properties page. At the bottom of the General tab, if Change Settings is present, click it. Then on the Driver tab, click Enable.

If you are prompted to restart the computer, the device is not enabled until the computer is restarted.

Disable a device

When you disable a device, the physical device stays connected to your computer, but the device driver is disabled. The drivers are available again when you enable the device. It can be useful to disable devices if you want to have more than one hardware configuration for your computer, or if you have a portable computer that you use at a docking station.

If you are prompted to restart the computer, the device will not be disabled and will continue to function until the computer is restarted.

After you disable a device and restart your computer (if necessary), the resources allocated to the device are free and can be allocated to another device.

Some devices cannot be disabled, such as devices for disk drives and processors.

To disable a Plug and Play device

  1. Open Device Manager.

  2. Right-click the specific device you want, and then click Disable.

    Important

    If you disable a device that is required to start the system, such as your hard disk drive then your system might not start successfully.

You can also disable a device from the device's Properties page. At the bottom of the General tab, if Change Settings is present, click it. Then on the Driver tab, click Disable.
Additional References

Installing Devices and their Drivers

View Information About a Device Driver

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version

Start or Stop a Non-Plug and Play Device Driver

Configure the Startup Type for a Non-Plug and Play Device Driver


Start or Stop a Non-Plug and Play Device Driver

This topic provides a procedure that you can use to start or stop the device drivers for devices that do not conform to the Plug and Play specification. For a Plug and Play device, see Enable or Disable a Plug and Play Device.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To start or stop a device driver for a non-Plug and Play device

  1. Open Device Manager.

  2. Click the View menu, and then click Show hidden devices.

  3. In the list of devices, double-click Non-Plug and Play Drivers, right-click the device you want, and then click Properties.

  4. On the Driver tab, click Start or Stop, and then click OK.

    Note

    If the Start button on the Driver tab is unavailable, the driver is already loaded.
Additional References

Installing Devices and their Drivers

View Information About a Device Driver

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version

Configure the Startup Type for a Non-Plug and Play Device Driver


Configure the Startup Type for a Non-Plug and Play Device Driver

This topic provides a procedure that you can use to configure how a non-Plug and Play device driver is started when you start your computer.

Caution

Improperly changing the startup type of a boot device or system device can cause the system to become unstable or to no longer boot, or cause the device to stop working altogether. Make sure that you fully understand the instructions before changing this setting.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To change the startup type for a non-plug and play device driver

  1. Open Device Manager.

  2. Click the View menu, and then click Show hidden devices.

  3. Double-click Non-Plug and Play Drivers, right-click a device, and then click Properties.

  4. On the Driver tab, under Startup, select a Type, and then click OK.

The Startup Type defaults to the type required by the driver when the driver is first installed. You can use the options shown in the following table to change the default. Use caution when changing the startup type; be sure that you fully understand the instructions before you change this setting.

Startup Type | Description
Automatic | Starts every time the system starts, after the boot devices and system devices start. Click this option for devices that are not critical to basic system operation.
Boot | Starts every time the system starts, before any other devices start. Click this option for critical devices that are essential to system operation.
Demand | Starts when the device is detected or it is needed for a specific event. Click this option for devices that are not critical to basic system operation nor that are required for device detection.
System | Starts every time the system starts, after the boot devices start. Click this option for critical devices that are essential to system operation.
Additional references

View Information About a Device Driver

Update or Change a Device Driver

Roll Back a Device Driver to a Previous Version

Start or Stop a Non-Plug and Play Device Driver


Configuring Device Properties

This section provides procedures that you can use to change the configuration of your hardware devices.

  • Understanding Device Configuration

  • Change Resource Settings for a Device

  • Change Settings for a Specific Device Type

  • Change Power Options for a Device

  • Upgrade from a Uniprocessor to a Multiprocessor Computer


Understanding Device Configuration

When you install a Plug and Play device, Windows automatically configures the device so it will work properly with the other devices that are installed on your computer. As part of that configuration process, Windows assigns a unique set of system resources to the device you are installing. These resources can include one or more of the following:

  • Interrupt request (IRQ) line numbers

  • Direct memory access (DMA) channels

  • Input/output (I/O) port addresses

  • Memory address ranges

For definitions of each of these terms, see the Device Management Glossary.

Each resource that is assigned to your device must be unique or else the device cannot function properly. For Plug and Play devices, Windows automatically configures these resources properly. However, you can manually configure devices by using Device Manager.

Generally, avoid changing resource settings manually, because when you do, the settings become fixed, and Windows will then have less flexibility when allocating resources to other devices. If too many resources become fixed, Windows may not be able to install new Plug and Play devices.

Occasionally, two devices require the same resources, resulting in a device conflict. If this occurs, you can manually change the resource settings to be sure each setting is unique. However some resources, such as interrupts on PCI devices, can be shared, depending on the drivers and computer.

Depending on the type of device you are installing, you might have to manually configure these settings. When you install a non-Plug and Play device, Windows cannot automatically configure the resource settings for the device. For instructions, see the manual that came with your device.

Caution

Changing resource settings improperly can disable your hardware and cause your computer to malfunction or become inoperable. Change resource settings only if you are certain that the new settings do not conflict with other hardware, or if a hardware manufacturer has provided specific resource settings for a device.
Additional references

Configuring Device Properties

Change Resource Settings for a Device

Change Settings for a Specific Device Type

Change Power Options for a Device

Upgrade from a Uniprocessor to a Multiprocessor Computer


Change Resource Settings for a Device

This topic provides a procedure that you can use to change the resources used by a device.

Caution

Changing resource settings improperly can disable your hardware and cause your computer to malfunction or become inoperable. Resource settings should be changed only by users who have expert knowledge of computer hardware and hardware configuration settings.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To change resource settings for a device

  1. Open Device Manager.

  2. Double-click the type of device you want to change.

  3. Double-click the specific device you want to change. If the device has resources settings that you can change, the Resources tab will appear in the dialog box.

  4. Click the Resources tab, and then clear the Use automatic settings check box. This check box might be unavailable if you cannot assign a specific resource to the device.

  5. In Setting based on, click the hardware configuration you want to change.

  6. In Resource settings, under Resource type, click the resource type you want to change. Your choices are as follows:

    • Direct memory access (DMA)

    • Interrupt request (IRQ)

    • Input/output (I/O) port

    • Memory address

  7. Click Change Setting, and then type a new value for the resource type.

  8. Repeat steps 2 through 7 as necessary.
Additional considerations
Important

Make sure that the new settings do not conflict with any other devices. If you have any device conflicts, they appear on the Resources tab under Conflicting device list.

  • Use automatic settings is not enabled for devices that have no other settings that you can configure. It is also not enabled for devices that are controlled by Plug and Play resources and should not be changed by the user.

  • You should need to assign resources manually only for some older Industry Standard Architecture (ISA) and Plug and Play basic input/output system (BIOS) devices. It is not usually necessary for you to change resource settings because resources are automatically allocated by the system when the hardware is installed.

Additional references

Configuring Device Properties


Change Settings for a Specific Device Type

This topic provides procedures that you can use to change settings that are specific to certain types of devices.

  • Change the settings for a network adapter

  • Change the settings for a COM or LPT port

  • Change the settings for a PS/2 mouse

  • Change the settings for an IDE controller

  • Change the region setting for a DVD drive

  • Change settings for an ISDN adapter

  • Change the settings for a multimedia device

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

Change the settings for a network adapter

Device properties for network adapters are device dependent. Read the device manufacturer's instruction manual to determine which settings you must change.

To change the settings for a network adapter

  1. Open Device Manager.

  2. Double-click Network adapters.

  3. Right-click the network adapter you want, and then click Properties.

  4. On the Advanced tab, make the appropriate changes you want.

Change the settings for a COM or LPT port

To change the settings for a COM or LPT port

  1. Open Device Manager.

  2. Double-click Ports (COM & LPT).

  3. Right-click the port you want, and then click Properties.

  4. On the Port Settings tab, make the changes you want.

    Note

    Most hardware devices that use ports set the port speed automatically. The defaults for modem port speed are specified in Phone and Modem Options in Control Panel, in the Hardware and Sound section.

Change the settings for a PS/2 mouse

To change the settings for a PS/2 mouse

  1. Open Device Manager.

  2. Double-click Mice and other pointing devices.

  3. Right-click PS/2 Compatible Mouse, and then click Properties.

  4. On the Advanced Settings tab, make the changes you want.

Change the settings for an IDE controller

Some of the advanced settings for IDE controllers are device dependent. Read the device manufacturer's instruction manual to determine which settings you can change.

You will not be able to change the setting in Device Type if the system has already detected an IDE device on an IDE channel. This prevents you from selecting None, which would disable the IDE device.

To change the settings for an IDE controller

  1. Open Device Manager.

  2. Double-click IDE ATA/ATAPI controllers, right-click the IDE device you want, and then click Properties.

  3. On the Advanced Settings tab, make the changes you want, and then click OK.

    Note

    The Advanced Settings tab might not appear for all IDE controller devices.

Change the regional settings for a DVD drive

Many software decoders require Direct Memory Access (DMA) in order to function. Check the settings of your Integrated Device Electronics (IDE) ATA/ATAPI controllers to ensure that DMA if available is selected in Transfer Mode. If applicable, check this setting for the Secondary IDE Channel also.

To change the region setting for a DVD drive

  1. Open Device Manager.

  2. Double-click DVD/CD-ROM drives, right-click the DVD drive you want, and then click Properties.

  3. On the DVD Region tab, make the changes you want.

    Note

    The DVD Region tab might not be available for all DVD drives.

To configure your DVD drive to play discs from other regions, select a geographic area from the list of regions. Typically, you would select the region in which you reside. It is not usually necessary to change the setting again.

The region settings can be changed only a limited number of times. When Changes remaining equals 1, and you select a new region, an alert will be displayed warning you that after this, you will only be able to play DVDs from that region. Be aware that you might not be able to change the region setting for some DVD hardware and software decoders.

Change the settings for an ISDN adapter

To change settings for an ISDN adapter

  1. Open Device Manager.

  2. Double-click Network adapters, right-click the Integrated Services Digital Network (ISDN) adapter card you want, and then click Properties.

  3. On the ISDN tab, in the Select the switch type or D-channel protocol list, click a switch type or a D-channel protocol, and then click Configure.

    Make the changes you want.

For information about how to configure ISDN adapter settings, see documentation provided by your telephone company or hardware manufacturer.

Change the settings for a multimedia device

Multimedia devices can include streaming audio or video devices, audio or video codecs, or MIDI devices.

To change the settings for a multimedia device

  1. Open Device Manager.

  2. Double-click Sound, video and game controllers.

  3. Right-click the device that you want, and then click Properties.

  4. Change the configurations that you want.

    Note

    The Properties button is enabled only if you have drivers other than Windows Driver Model (WDM) drivers on your computer. If the Properties button is not enabled, use the Resources tab to configure the device.
Additional references

Configuring Device Properties


Change Power Options for a Device

This topic provides a procedure you can use to configure how your device interacts with Windows power options. This includes settings that control how the device consumes power under different conditions, and how Windows responds to events from the device when the computer is operating in various power-saving states.

You can use the power options to configure a device to "wake up" from a low-power state for an event. One example of the effect of doing so is that an incoming modem call will alert the system to service the call even if the system is in hibernation. You can also specify whether the operating system should turn off a particular device if it is not occupied, servicing a call for example.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

To change the power options for a device

  1. Open Device Manager.

  2. Double-click the type of device for which you want to change power options.

  3. Right-click the device you want, and then click Properties.

  4. On the Power Management tab, change the settings you want.
Note

The Power Management tab appears only for device drivers that support power option standards.
Additional references

Configuring Device Properties


Upgrade from a Uniprocessor to a Multiprocessor Computer

This topic provides a procedure that you can use to configure specific devices when you upgrade your computer from a single processor to a multiprocessor system.

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure.

Caution

Upgrading from a uniprocessor to a multiprocessor computer can disable your hardware and cause your computer to malfunction or become inoperable. Upgrading should be done only by users who have expert knowledge of computer hardware and hardware configuration settings.

To upgrade from a uniprocessor to a multiprocessor computer

  1. Open Device Manager.

  2. Double-click Computer.

  3. Right-click the computer model, and then click Properties.

  4. On the Driver tab, click Update Driver. This starts the Hardware Update Wizard.

  5. Select Browse my computer for driver software.

  6. Select Let me pick from a list of device drivers on my computer.

  7. On the Update Driver Software page, click the appropriate computer type from the Model list, and then click Next.

  8. When driver installation is finished, click Close to exit the wizard.

  9. If Windows prompts you to restart your computer, click Restart.
Additional references

Configuring Device Properties


Uninstalling and Reinstalling Devices

This section provides procedures that you can use to uninstall and reinstall your hardware devices.

  • Understanding the Process of Uninstalling Devices

  • Uninstall or Reinstall a Device

  • Remove a Driver Package from the Driver Store

  • Eject or Unplug a Device

  • Undock a Portable Computer


Understanding the Process of Uninstalling Devices

Uninstalling a Plug and Play device

Typically, you do not need to uninstall a Plug and Play device. Just disconnect or unplug the device so that Windows does not load or use the driver. Some devices might require that you turn off the computer first. To ensure that you do this properly, see the device manufacturer's instruction manual.

Uninstalling a non-Plug and Play device

Uninstalling a non-Plug and Play device typically involves two steps:

  1. Using Device Manager to uninstall the device.

  2. Removing the device from your computer.

Use Device Manager to uninstall a non-Plug and Play device. After uninstalling a device, you must physically disconnect or remove the device from your computer. For example, if the device is connected to a port on the outside of your computer, shut down your computer, disconnect the device from the port, and then unplug the power cord for the device.

Enabling and disabling versus installing and uninstalling

Instead of uninstalling a device that you might attach again, such as a modem, you can choose to disable a Plug and Play device. When you disable a device, the device stays physically connected to your computer, but Windows updates the system registry so that the device drivers for the device are not loaded when you start your computer. The drivers are available again when you enable the device. Disabling devices is useful if you want more than one hardware configuration for your computer, or if you have a portable computer that you use at a docking station.

For procedures about how to uninstall, reinstall, and roll back devices and their drivers, see Uninstall or Reinstall a Device, and Roll Back a Device Driver to a Previous Version.

For more information about hardware and procedures for installing devices, see Installing Devices and their Drivers and Configuring Device Properties.

Additional references

Uninstalling and Reinstalling Devices


Uninstall or Reinstall a Device

This topic provides procedures that you can use to uninstall and reinstall your hardware devices.

  • Uninstall a device

  • Reinstall a Plug and Play device

  • Reinstall a non-Plug and Play device

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. Review the details in "Additional considerations" in this topic.

Uninstall a device

Generally, you do not need to use Device Manager to uninstall a Plug and Play device. Simply disconnect the Plug and Play device from your computer. You might have to restart your computer, however, depending on the type of device. For more information, see the instructions provided by the manufacturer of your device.

To uninstall a device

  1. Open Device Manager.

  2. Double-click the type of device that you want to uninstall.

  3. Right-click the specific device you want, and then click Uninstall. You can also double-click the device, and then on the Driver tab, click Uninstall.

  4. In the Confirm Device Removal page, select Delete the driver software for this device if you also want to remove the device driver package from the driver store. .

    The Delete the driver software for this device option removes the package from the driver store. It does not remove the currently installed driver for any other operational devices that use the same driver. If you remove the driver from the store, and the device is connected to the computer again, Windows must search for a copy of the driver package in the standard search locations, including possibly prompting the user for media. This option is the equivalent of running the command: pnputil -d -f <package.inf>. For more information, see Remove a Driver Package from the Driver Store.

  5. Click OK to complete the uninstall process.

  6. When the uninstall process is complete, unplug the device from the computer.

    If you are prompted to restart the computer, the removal is not completed and the device might continue to function until the computer is restarted.

Reinstall a Plug and Play device

Reinstall a device only if it is working improperly or it has stopped working altogether. Before you reinstall a device, try to restart your computer and check the device to determine whether it is functioning properly. If it is not, try reinstalling the device.

To reinstall a Plug and Play device

  1. Open Device Manager.

  2. Follow the instructions in the preceding procedure to uninstall the device.

Reinstall a non-Plug and Play device

Reinstall a device only if it is working improperly or it has stopped working altogether. Before you reinstall a device, try to restart your computer and check the device to determine whether it is functioning properly. If it is not, try reinstalling the device.

To reinstall a non-Plug and Play device

  1. Open Device Manager.

  2. Follow the instructions in the first procedure to uninstall the device.

  3. Right-click the top node in the details pane.

  4. Click Add legacy hardware.

  5. In the Add Hardware Wizard, click Next, and then follow the instructions on your screen.
Additional considerations
  • By default, membership in the Administrators group, or equivalent, is the minimum required to modify device drivers. A standard user can modify a driver only if the device setup class for the driver is in the Allow non-administrators to install drivers for these device classes computer policy. For more information, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

Additional references

Understanding the Process of Uninstalling Devices

Remove a Driver Package from the Driver Store

Eject or Unplug a Device

Undock a Portable Computer

Command-line syntax notation


Remove a Driver Package from the Driver Store

The driver store is a protected area of the computer that contains device driver packages that have been approved for installation on the computer. For more information about the driver store, see Understanding Device and Driver Installation.

Removing a device driver package from the store does not uninstall any currently operational devices that use its driver. The installed copies of the driver files are not changed. Only the copy of the driver package in the store is deleted. After removing the package from the store, if a new device that uses this driver is plugged into the computer, Windows must search for the driver package by using the standard locations, which can include prompting the user for media.

This topic provides procedures that you can use to remove a device driver package from the driver store.

  • Determine the name of the driver package in the driver store

  • Remove a staged driver package from the driver store

Membership in the local Administrators group, or equivalent, is the minimum required to complete this procedure. Review the details in "Additional considerations" in this topic.

Determine the name of the driver package in the driver store

Before you can remove the driver package, you need to know its name in the driver store. The .inf file name is changed to OEM#.inf, where # is a unique number.

To determine the name of the driver package in the driver store

  1. Open a command prompt that has administrator privileges. Click Start, All Programs, and Accessories, then right-click Command Prompt, and then click Run as Administrator.

    Note

    The PnPUtil command-line tool does not work unless you run the command prompt as an administrator.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. At the command prompt, type the command:

    pnputil.exe -e

  4. Read the entries in the output to find the description of your package and its file name.

Remove a staged driver package from the driver store

After you know the .inf file name of the package in the driver store, you can remove the device driver package.

To remove a staged driver package from the driver store

  1. Open a command prompt with administrator privileges. Click Start, All Programs, and Accessories, right-click Command Prompt, and then click Run as Administrator.

    Note

    The PnPUtil tool does not work unless you run the command prompt as an administrator.

  2. If the User Account Control dialog box appears, confirm that the action it displays is what you want, and then click Continue.

  3. At the command prompt, type the command:

    pnputil.exe -d Oem#.inf

    Make sure to replace the # with the number of the .inf file you want to remove.

    Note

    To see all of the command-line parameters for the PnPUtil tool, type the following at the command prompt: pnputil -?

  4. If the computer reports that the driver package is in use by a currently installed device, then you must either uninstall the device first, or use the -f on the pnputil command to force deletion of the package.

Additional Considerations
  • By default, membership in the Administrators group, or equivalent, is the minimum required to modify drivers in the driver store. A standard user can be delegated permission to install or uninstall a driver package. To delegate the right, place the device setup class for the driver in the policy Allow non-administrators to install drivers for these device classes. For more information, see Configure Computer Policy to Allow Non-Administrators to Install Specific Devices.

Additional references

Uninstalling and Reinstalling Devices

Understanding Device and Driver Installation

Stage a Device Driver in the Driver Store

Understanding the Process of Uninstalling Devices

Uninstall or Reinstall a Device

Command-line syntax notation


Eject or Unplug a Device

This topic provides a procedure that you can use to safely eject or unplug a removable device.

Caution

Unplugging or ejecting a device that supports safe removal without first using the Safe Removal application to warn the system can cause data to be lost or your system to become unstable. For example, if a device is unplugged during a data transfer, data loss is likely. If you use Safe Removal, however, you can warn the system before you unplug or eject a device, preventing possible loss of data.

Any user account can be used to complete this procedure.

To eject or unplug a device

  1. In the notification area of the taskbar, click the Safe Removal icon ( Safely Remove Hardware Icon).

    Safe Removal displays a pop-up menu with a list of Plug and Play devices that support safe removal and that are currently attached to the system.

    If you do not see the device you want in the menu, your device does not support safe removal, and you cannot unplug or eject your device by using Safe Removal.

  2. In the list of devices, select the device that you want to unplug or eject.

    A notification appears stating that it is now safe to unplug or eject the device.

    Note

    For removable storage devices that can safely be removed while the computer is on, the computer disables write caching by default. It does this so that the devices can be removed without loss of data.
Additional references

Uninstalling and Reinstalling Devices

Understanding the Process of Uninstalling Devices

Undock a Portable Computer


Undock a Portable Computer

This topic provides a procedure that you can use to safely remove a portable computer from a docking station.

Caution

Removing a portable computer without using Undock can result in system instability, data loss, or even hardware damage. To avoid loss or damage, use Undock to undock your computer, or shut down the system and undock the portable computer while your system is off. Undocking a portable computer while it is in either standby mode or hibernate mode can result in data loss and system instability.

Any user account can be used to complete this procedure.

To undock a portable computer

  1. Click Start.

  2. On the Start menu, to the right of the Power down and Lock buttons, click the arrow button to reveal the Shutdown Options menu.

    If your computer is recognized by Windows as a portable computer that supports undocking, then Undock appears on this menu. If you computer is not recognized as a computer that supports undocking, then Undock does not appear.

  3. Click Undock.

  4. After you receive notification that it is safe to do so, undock your portable computer.I If you have a motorized docking station, your portable computer will undock automatically.
Additional considerations
  • Undock appears on the Shutdown Options menu only if the computer is Advanced Configuration and Power Interface (ACPI)-enabled and recognized as a portable computer in a docking station. If Undock does not appear on the Shutdown Options menu, your computer is not ACPI-enabled, or might not support undocking.

  • Some computers have an eject button on the docking station. Pressing the eject button instead of following this procedure also undocks the laptop. For more information, see the documentation provided with your docking station.

  • For optimal laptop performance, change your power scheme in Control Panel. This option is available in the Mobile PC category as Manage the battery power, or Power Options in Classic View.

Additional references

Uninstalling and Reinstalling Devices

Eject or Unplug a Device


Additional Device Manager Resources

For more information about Device Management, see the following resources on the Microsoft Web site:

Device Management and Installation Portal on Windows Server TechCenter
  • Device Management Documentation for IT Pros (http://go.microsoft.com/fwlink/?LinkId=62923)

Specific documents available include:
  • Getting Started with Device Management (http://go.microsoft.com/fwlink/?LinkId=63116)

  • Device Management Operations Guide (http://go.microsoft.com/fwlink/?LinkId=63117)

  • Device Management Technical Reference (http://go.microsoft.com/fwlink/?LinkId=63118)


Device Management Glossary

The following terms are used throughout the documentation on device installation and management. In the context of device management, these terms sometimes have a specialized meaning.

device
Any piece of equipment that can be attached to a network or computer; for example, a printer, joystick, adapter, or modem card, or any other peripheral equipment. A device requires a device driver to function with Windows.

device conflict
A conflict that occurs when the same system resources have been allocated to two or more devices. System resources include interrupt request (IRQ) lines, direct memory access (DMA) channels, input/output (I/O) ports, and memory addresses.

device driver
Software that allows Windows to communicate with a specific hardware device. Before Windows can use any new hardware, a device driver must be installed.

device driver package
The files needed to install and configure a device driver. A device driver package can include an installer program, an .inf file, and a security catalog file, in addition to the actual device driver files.

disable
To make a device nonfunctional. For example, if you disable a device in a hardware configuration, you cannot use the device when your computer uses that hardware configuration. Disabling a device frees the resources that were allocated to the device.

direct memory access (DMA)
Memory access that does not involve the microprocessor. DMA is frequently used for data transfer directly between memory and a peripheral device such as a disk drive.

dock
To connect a portable computer to a docking station.

driver store (or protected driver store)
A secure area of the computer in which Windows places device driver installation packages before they are made operational. All driver packages must be staged in the store as part of the installation process.

enable
To make a device functional. For example, if a device in your hardware configuration settings is enabled, the device is available for use when your computer uses that hardware configuration.

hardware configuration
Resource settings that have been allocated for a specific device. Each device on your computer has a hardware configuration, which may consist of IRQ lines, DMA, an I/O port, or memory address settings.

input/output (I/O) port
A channel through which data is transferred between a device and the microprocessor. The port appears to the microprocessor as one or more memory addresses that it can use to send or receive data.

install
When referring to hardware, to physically connect the device to your computer, to load device drivers onto your computer, and to configure device properties and settings.

interrupt
A request for attention from the processor. When the processor receives an interrupt, it suspends its current operations, saves the status of its work, and transfers control to a special routine known as an interrupt handler, which contains the instructions for dealing with the particular situation that caused the interrupt.

interrupt request (IRQ)
A signal sent by a device to get the attention of the processor when the device is ready to accept or send information. Each device sends its interrupt requests over a specific hardware line. Each device must be assigned a unique IRQ number.

local computer
The computer that you are currently logged on to as a user. More generally, a local computer is a computer that you can access directly without using a communications line or a communications device, such as a network adapter or a modem.

memory address
A portion of computer memory that can be allocated to a device or used by a program or the operating system. Devices are usually allocated a range of memory addresses.

non-Plug and Play
A device, such as a printer, modem, or game controller, that requires manual configuration of hardware settings before it can be used. Non-Plug and Play devices are becoming increasingly rare as manufacturers stop producing them in favor of Plug and Play devices. The term Non-Plug and Play typically applies to older pieces of equipment.

peripheral connection interface (PCI)
A specification introduced by Intel Corporation that defines a local bus system that allows up to 10 PCI-compliant expansion cards to be installed in the computer.

Plug and Play
A set of specifications developed by Intel Corporation that allows a computer to automatically detect and configure a device and install the appropriate device drivers.

port
A connection point on your computer where you can connect devices that pass data into and out of a computer.

remote computer
A computer that you can access only by using a communications line or a communications device, such as a network card or a modem.

resources
Generally, any part of a computer system or network, such as a disk drive, printer, or memory, that can be allocated to a running program or a process.

For device management, any of four system components that control how the devices on a computer work. These four system resources are interrupt request (IRQ) lines, direct memory access (DMA) channels, input/output (I/O) ports, and memory addresses.

staging
The process of putting a device driver into a driver store so that it can then be installed. All packages must be staged before they can be installed. Only an administrator or user account that has appropriate delegated permissions can place a device driver in the store. Windows checks a device driver for a valid signature during driver staging.

undock
To detach a portable computer from a docking station.

uninstall
When referring to software, the act of removing program files and folders from your hard disk and removing related data from your registry so the software is no longer available.

When referring to a device, the act of removing the corresponding device drivers from your hard disk and physically removing the device from your computer.


Command-line syntax notation

The following table describes the notation used to indicate command-line syntax.

Notation | Description
Text without brackets or braces | Items you must type as shown
<Text inside angle brackets> | Placeholder for which you must supply a value
[Text inside square brackets] | Optional items
{Text inside braces} | Set of required items; choose one
Vertical bar (|) | Separator for mutually exclusive items; choose one
Ellipsis (…) | Items that can be repeated